class Kind {
	private int nummer;
	private Kind nachfolger;

	Kind(int nummer, Kind naechfolger) {
		this.nummer = nummer;
		this.nachfolger = naechfolger;
	}

	int getNummer() {
		return this.nummer;
	}

	Kind getNachfolger() {
		return this.nachfolger;
	}

	void setNachfolger(Kind nachfolger) {
		this.nachfolger = nachfolger;
	}
}

class Kreis {
	int anzahl;
	Kind aktuelles;

	// Vorbedingung: anzahl >= 1 (vorgegeben)
	Kreis(int anzahl) {
		this.anzahl = anzahl;
		Kind kind = new Kind(anzahl, null);
		this.aktuelles = kind;
		for (int i = anzahl - 1; i >= 1; i--) {
			kind = new Kind(i, kind);
		}
		this.aktuelles.setNachfolger(kind);
	}

	// vorgegeben
	boolean istLeer() {
		return this.anzahl == 0;
	}

	// silbe >= 1 (gesucht)
	Kind abzaehlen(int silbe) {
		Kind kind = this.aktuelles;
		for (int i = 1; i < silbe; i++) {
			kind = kind.getNachfolger();
		}
		Kind ausgeschieden = kind.getNachfolger();
		kind.setNachfolger(ausgeschieden.getNachfolger());
		this.aktuelles = kind;
		this.anzahl = this.anzahl - 1;
		return ausgeschieden;
	}

	// gesucht
	void print() {
		if (this.istLeer()) {
			System.out.println("Kreis ist leer");
		} else {
			Kind kind = this.aktuelles;
			for (int i = 1; i < this.anzahl; i++) {
				System.out.print(kind.getNummer() + "->");
				kind = kind.getNachfolger();
			}
			System.out.println(kind.getNummer());
		}
	}
}

public class UE13Aufgabe15 {

	// vorgegeben
	public static void main(String[] args) {
		final int anzahl = 6;
		final int silbe = 5;
		Kreis kreis = new Kreis(anzahl);
		kreis.print();
		while (!kreis.istLeer()) {
			Kind ausgeschieden = kreis.abzaehlen(silbe);
			System.out.println("raus: " + ausgeschieden.getNummer());
			kreis.print();
		}
	}

}
