// http://www.ips.tu-braunschweig.de/struckmann/prog13/klausur2b.pdf

class Node {
	int value;
	Tree left, right;

	public Node(int value, Tree tree) {
		this.value = value;
		this.left = tree.createTree();
		this.right = tree.createTree();
	}
}

class Tree {
	protected Node root;

	public Tree() {
		root = null;
	}

	public boolean isEmpty() {
		return root == null;
	}

	public void insert(int x) {
		if (isEmpty())
			root = new Node(x, this);
		else if (x < root.value)
			root.left.insert(x);
		else
			root.right.insert(x);
	}

	public String toString() {
		if (isEmpty())
			return "";
		else {
			String s = ":" + root.value + ";";
			return root.left + s + root.right;
		}
	}

	protected Tree createTree() {
		return new Tree();
	}
}

// Aufgabe
class SearchTree extends Tree {

	protected Tree createTree() {
		return new SearchTree();
	}

	public boolean contains(int x) {
		if (isEmpty()) {
			return false;
		} else if (x == root.value) {
			return true;
		} else if (x < root.value) {
			return ((SearchTree) root.left).contains(x);
		} else {
			return ((SearchTree) root.right).contains(x);
		}
	}
}

public class UE13Aufgabe17 {
	public static void main(String[] args) {
		SearchTree t = new SearchTree();
		t.insert(2);
		t.insert(3);
		t.insert(1);
		t.insert(3);
		t.insert(2);
		System.out.println(t);
		System.out.println(t.contains(1));
		System.out.println(t.contains(4));
	}
}
