class ExtList extends List {

	ExtList() {
		super();
	}

	void append(int i) {
		if (!isElement(i)) {
			super.append(i);
		}
	}

	void change(int i) {
		if (!isElement(i)) {
			this.prepend(i);
		} else {
			this.remove(i);
		}
	}

	boolean isElement(int i) {
		Element help = this.first;
		while (help != null) {
			if (help.value == i) {
				return true;
			}
			help = help.next;
		}
		return false;
	}

	void prepend(int i) {
		this.first = new Element(i, this.first);
		if (this.last == null) { // einziges Element
			this.last = this.first;
		}
	}

	void remove(int i) {
		Element before = null;
		Element help = this.first;
		while (help != null) {
			if (help.value == i) {
				if (before != null) {
					before.next = help.next;
				} else { // Element == first
					this.first = help.next;
				}
				if (help.next == null) { // u.U. last anpassen
					this.last = before;
				}
				return; // jedes Element kann max. einmal vorhanden sein
			}
			before = help;
			help = help.next;
		}
	}
}

// testprogramm
public class UE13Aufgabe6 {

	public static void main(String[] args) {
		ExtList l = new ExtList();
		l.append(5);
		l.append(4);
		l.append(5);
		l.append(2);
		l.append(7);
		l.append(1);
		l.append(1);
		l.print();
		l.change(4);
		l.print();
		l.change(8);
		l.print();
		l.change(1);
		l.print();
	}

}
